UNIT mTGCircleWP;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses Windows, Graphics, SysUtils, mTGeoObj, mTGPoint, mTGCircle;

type
   TGCircleWP = CLASS(TGCircle)
     // weitere Attribute
     protected
        MidPt  : TGPoint;
        PeriPt : TGPoint;

     // weitere Methoden
     public
        constructor Create(iP1,iP2:TGPoint; iCol:TColor);
        procedure Move(dx, dy: Integer; target: TCanvas); override;
        procedure Update(target: TCanvas); override;
        function Info: String; override;
   end;

implementation

//+---------------------------------------------------------------------
//|         TGCircleWP: Methodendefinition
//+---------------------------------------------------------------------

//-------- Create (public) ---------------------------------------------
constructor TGCircleWP.Create(iP1, iP2: TGPoint; iCol: TColor);
  var ix, iy : Integer;
begin
  ix := iP1.GetPos.x;
  iy := iP1.GetPos.y;
  Inherited create(ix, iy, 0, iCol);
  MidPt  := iP1;
  PeriPt := iP2;
  r := Round(Sqrt(Sqr(x - PeriPt.GetPos.x) + Sqr(y - PeriPt.GetPos.y)));
end;

//--------- Move (public) ------------------------------------------------
procedure TGCircleWP.Move(dx, dy: Integer; target: TCanvas);
  begin
  end;

//--------- Update (public) ----------------------------------------------
procedure TGCircleWP.Update(target: TCanvas);
  begin
  HideIt(target);
  x := MidPt.GetPos.x;
  y := MidPt.GetPos.y;
  r := Round(Sqrt(Sqr(x - PeriPt.GetPos.x) + Sqr(y - PeriPt.GetPos.y)));
  DrawIt(target);
  end;

//--------- Info (public) ------------------------------------------------
function TGCircleWP.Info: String;
  begin
  Result := 'Abhngiger Kreis';
  end;

end.
