UNIT mTGQuadrat;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses graphics, SysUtils, mTGeoObj;

type
   TGQuadrat = CLASS(TGeoObj)

     // weitere Attribute
     protected
         len : Integer;

     // weitere Methoden
     public
        constructor Create(ix,iy,ilen:Integer; iCol:TColor);
        procedure DrawIt(target:TCanvas); override;
        procedure HideIt(target:TCanvas); override;
        function Dist(mx, my: Integer): Double; override;
        function Info: String; override;
   end;

implementation

//+---------------------------------------------------------------------
//|         TGQuadrat: Methodendefinition
//+---------------------------------------------------------------------

//-------- Create (public) ---------------------------------------------
constructor TGQuadrat.Create(ix,iy,ilen:Integer; iCol:TColor);
begin
  Inherited Create(ix, iy, iCol);
  len := iLen;
end;

//-------- DrawIt (public) ---------------------------------------------
procedure TGQuadrat.DrawIt(target:TCanvas);
begin
  With target do begin
    Pen.Color   := col;
    Brush.Style := bsClear;
    Rectangle(x, y, x+len, y+len);
    end;
end;

//-------- HideIt (public) ---------------------------------------------
procedure TGQuadrat.HideIt(target:TCanvas);
begin
  With target do begin
    Pen.Color   := clWhite;
    Brush.Style := bsClear;
    Rectangle(x, y, x+len, y+len);
    end;
end;

//--------- Dist (public) ------------------------------------------------
function TGQuadrat.Dist(mx, my: Integer): Double;

  function DistPtQuad(xm, ym, lux, luy, len: Integer): Double;
     { liefert den Abstand von der nchstgelegenen Seite }
    var len2, d1, d2 : Integer;
    begin
    len2 := len div 2;
    d1 := Abs(len2 - Abs(Round(xm) - (lux + len2)));
    d2 := Abs(len2 - Abs(Round(ym) - (luy - len2)));
    If d1 < d2 then
      If (ym >= luy - len) and (ym <= luy) then
        Result := d1
      else
        Result := d2
    else
      If (xm >= lux) and (xm <= lux + len) then
        Result := d2
      else
        Result := d1;
    end;
    
  begin
  Result := DistPtQuad(mx, my, x, y + len, len);
  end;

//--------- Info (public) ------------------------------------------------
function TGQuadrat.Info: String;
  begin
  Result := 'Quadrat (' + IntToStr(X) + '|' + IntToStr(Y) + '), Lnge ' + IntToStr(len);
  end;

end.
